package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.Account;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: AccountType
// UnionValue: AnchorLedger

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("AnchorLedger")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class AnchorLedger implements Account {
	public final AccountType type = AccountType.ANCHOR_LEDGER;
	private Url url;
	private long minorBlockSequenceNumber;
	private long majorBlockIndex;
	private java.time.OffsetDateTime majorBlockTime;
	private Url[] pendingMajorBlockAnchors;
	private PartitionSyntheticLedger[] sequence;

    //
	public Url getUrl() {
	    return url;
	}
	public void setUrl(final Url value) {
	    this.url = value;
	}

	public AnchorLedger url(final Url value) {
	    setUrl(value);
	    return this;
	}
	public AnchorLedger url(final String value) {
	    setUrl(Url.toAccURL(value));
	    return this;
	}
	public long getMinorBlockSequenceNumber() {
	    return minorBlockSequenceNumber;
	}
	public void setMinorBlockSequenceNumber(final long value) {
	    this.minorBlockSequenceNumber = value;
	}

	public AnchorLedger minorBlockSequenceNumber(final long value) {
	    setMinorBlockSequenceNumber(value);
	    return this;
	}
	public long getMajorBlockIndex() {
	    return majorBlockIndex;
	}
	public void setMajorBlockIndex(final long value) {
	    this.majorBlockIndex = value;
	}

	public AnchorLedger majorBlockIndex(final long value) {
	    setMajorBlockIndex(value);
	    return this;
	}
	public java.time.OffsetDateTime getMajorBlockTime() {
	    return majorBlockTime;
	}
	public void setMajorBlockTime(final java.time.OffsetDateTime value) {
	    this.majorBlockTime = value;
	}

	public AnchorLedger majorBlockTime(final java.time.OffsetDateTime value) {
	    setMajorBlockTime(value);
	    return this;
	}
	public Url[] getPendingMajorBlockAnchors() {
	    return pendingMajorBlockAnchors;
	}
	public void setPendingMajorBlockAnchors(final Url[] value) {
	    this.pendingMajorBlockAnchors = value;
	}

	public AnchorLedger pendingMajorBlockAnchors(final Url[] value) {
	    setPendingMajorBlockAnchors(value);
	    return this;
	}
	public PartitionSyntheticLedger[] getSequence() {
	    return sequence;
	}
	public void setSequence(final PartitionSyntheticLedger[] value) {
	    this.sequence = value;
	}

	public AnchorLedger sequence(final PartitionSyntheticLedger[] value) {
	    setSequence(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.url == null)) {
            marshaller.writeUrl(2, this.url);
        }
        if (!(this.minorBlockSequenceNumber == 0)) {
            marshaller.writeUint(3, this.minorBlockSequenceNumber);
        }
        if (!(this.majorBlockIndex == 0)) {
            marshaller.writeUint(4, this.majorBlockIndex);
        }
        if (!(this.majorBlockTime == null)) {
            marshaller.writeTime(5, this.majorBlockTime);
        }
        if (!(this.pendingMajorBlockAnchors == null || this.pendingMajorBlockAnchors.length == 0)) {
            marshaller.writeUrl(6, this.pendingMajorBlockAnchors);
        }
        if (!(this.sequence == null)) {
            marshaller.writeValue(7, sequence);
        }
        return marshaller.array();
    }
}
